#property copyright ""
#property link      ""

#property indicator_separate_window
#property indicator_minimum 1.0
#property indicator_buffers 5
#property indicator_color1 Green
#property indicator_color2 Red
#property indicator_color3 Yellow
#property indicator_color4 Lime
#property indicator_color5 Orchid

//
//
//
//
//

extern int    TimeFrame       = 0;
extern int    ADX_Period      = 14;
extern int    ADX_Level       = 20;
extern int    sBarLevel       = 5;

extern bool   _ADXstyleLine   = FALSE;
extern bool   pADXstyleLine   = FALSE;
extern bool   nADXstyleLine   = TRUE;

extern string note_sBarLevel  = "sBarLevel:1-77(bar position)";
extern string note_ADXstyle = " ADXstyle: Line/Dot";
extern string note_TimeFrames = "M1;5,15,30,60H1;240H4;1440D1;10080W1;43200MN";

//
//
//
//
//

double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double buffer5[];

//
//
//
//
//

int init()
{
   SetIndexBuffer(0, buffer4); SetIndexStyle(0, DRAW_ARROW);  SetIndexArrow(0, 167); SetIndexEmptyValue(0, EMPTY_VALUE);
   SetIndexBuffer(1, buffer5); SetIndexStyle(1, DRAW_ARROW);  SetIndexArrow(1, 167); SetIndexEmptyValue(1, EMPTY_VALUE);

   SetIndexBuffer(2, buffer1);
         if (_ADXstyleLine) 
                  SetIndexStyle(2, DRAW_LINE);
         else {   SetIndexStyle(2, DRAW_ARROW); SetIndexArrow(2, 158); SetIndexEmptyValue(2, EMPTY_VALUE); }
   SetIndexBuffer(3, buffer2);
         if (pADXstyleLine) 
                  SetIndexStyle(3, DRAW_LINE);
         else {   SetIndexStyle(3, DRAW_ARROW); SetIndexArrow(3, 158); SetIndexEmptyValue(3, EMPTY_VALUE); }
   SetIndexBuffer(4, buffer3);
         if (nADXstyleLine) 
                  SetIndexStyle(4, DRAW_LINE);
         else {   SetIndexStyle(4, DRAW_ARROW); SetIndexArrow(4, 158); SetIndexEmptyValue(4, EMPTY_VALUE); }

   SetIndexDrawBegin(1, 2);
   SetIndexDrawBegin(2, 2);
   SetIndexDrawBegin(3, 2);
   SetIndexDrawBegin(4, 2);
   
   //
   //
   //
   //
   //
   
   TimeFrame = MathMax(TimeFrame, Period());
   string timeFrameName= "";
   switch (TimeFrame)
      {
         case 1:     timeFrameName = "M1";    break;
         case 5:     timeFrameName = "M5";    break;
         case 15:    timeFrameName = "M15";   break;
         case 30:    timeFrameName = "M30";   break;
         case 60:    timeFrameName = "H1";    break;
         case 240:   timeFrameName = "H4";    break;
         case 1440:  timeFrameName = "D1";    break;
         case 10080: timeFrameName = "W1";    break;
         case 43200: timeFrameName = "MN";    break;
         default:    timeFrameName = "TF0";
   }

   //
   //
   //
   //
   //
      
   IndicatorShortName("Wilde\'s DMI (" + ADX_Period + ") Filter sBar [" + timeFrameName + "]");
            SetIndexLabel(0, "posDI [" + TimeFrame + "]Up");
            SetIndexLabel(1, "negDI [" + TimeFrame + "]Down");
            SetIndexLabel(2, "DMI [" + TimeFrame + "] Level < " + ADX_Level + "");
            SetIndexLabel(3, "DMI [" + TimeFrame + "] Up");
            SetIndexLabel(4, "DMI [" + TimeFrame + "] Down");
            SetIndexDrawBegin(0, 2);
   return (0);
}
int deinit() { return (0); }

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           limit=MathMax(limit,TimeFrame/Period());

   //
   //
   //
   //
   //

   for(i=limit;i>=0;i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         double cAdx = iCustom(NULL,TimeFrame,"Wilder\'s DMI book",ADX_Period,2,y);
         double pAdx = iCustom(NULL,TimeFrame,"Wilder\'s DMI book",ADX_Period,2,y+1);
         double cDmp = iCustom(NULL,TimeFrame,"Wilder\'s DMI book",ADX_Period,0,y);
         double cDmm = iCustom(NULL,TimeFrame,"Wilder\'s DMI book",ADX_Period,1,y);
      
         if (cAdx > pAdx) 
               { buffer2[i] = sBarLevel; buffer3[i] = EMPTY_VALUE; }
         else  { buffer2[i] = EMPTY_VALUE; buffer3[i] = sBarLevel; }
         
         if (cAdx < ADX_Level) buffer1[i] = sBarLevel + 5;
         if (cDmp  > cDmm)     buffer4[i] = sBarLevel + 2;
         if (cDmp  < cDmm)     buffer5[i] = sBarLevel + 2;
   }
   return (0);
}